package com.hello2morrow.sonargraph.languageprovider.cplusplus.controller.settings

import groovy.json.JsonSlurper

import com.hello2morrow.sonargraph.languageprovider.cplusplus.model.settings.DirectoryBean

import de.schlichtherle.truezip.file.TFile

class CMakeJsonHelper
{
    public static List<DirectoryBean> importCommandFile(TFile jsonFile, StringBuilder buffer)
    {
        def slurper = new JsonSlurper()
        def jsonData = null;
        def fileList = []
        def optMap = [:]

        try
        {
            jsonFile.withReader
            {
                jsonData = slurper.parse(it)
            }

            def map = [:]

            for (Map<String, String> entry : jsonData)
            {
                String cmd = entry.get("command")
                String fileName = entry.get("file")

                if (cmd == null || fileName == null)
                {
                    // Data do not have the expected structure
                    return null
                }
                buffer.append(cmd).append(": ").append(fileName).append('\n')

                String[] options = cmd.split("\\s+")

                // Make sure that we do not have identical copies of large lists
                List<String> optList = options[1 .. -5].toList()
                List<String> list = map[optList]

                if (list == null)
                {
                    map.put(optList, optList)
                }
                else
                {
                    optList = list
                }

                TFile file = new TFile(fileName)

                if (!fileList.contains(file))
                {
                    optMap[file] = optList
                    fileList.add(new TFile(file))
                }
            }
        }
        catch (Throwable t)
        {
            return null
        }
        return DirectoryBeanHelper.createRoots(fileList, optMap)
    }
}
